//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color5  LimeGreen
#property indicator_color6  PaleVioletRed
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_color7  LimeGreen
#property indicator_color8  PaleVioletRed
#property indicator_style7  STYLE_DOT
#property indicator_style8  STYLE_DOT


extern int    DrawBars      = 0;
extern int    BBPeriod      = 20;
extern int    BBPrice       = 0;
extern double BBDeviations1 =  2;
extern double BBDeviations2  = 3;
extern color  WickColor     = Gray;
extern color  BodyUpColor   = LimeGreen;
extern color  BodyDownColor = PaleVioletRed;
extern int    BodyWidth     = 3;
extern bool   DrawAsBack    = false;
extern string UniqueID      = "BB bars 1";
extern bool   TouchesVisible = true;
extern color  TouchUpColor1 = Orange;
extern color  TouchUpColor2 = LimeGreen;
extern color  TouchDnColor1 = HotPink;
extern color  TouchDnColor2 = Red;
extern double TouchesTolerance = 4;
extern int    ArrowsSize       = 1;
extern int    ArrowsCode       = 3;

//
//
//
//
//

double open[];
double close[];
double high[];
double low[];
double bandUp[];
double bandDn[];
double bandUp2[];
double bandDn2[];
int    window;
double tolerance;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,open);  SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(1,close); SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(2,high);  SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(3,low);   SetIndexStyle(3,DRAW_NONE);
   SetIndexBuffer(4,bandUp);
   SetIndexBuffer(5,bandDn);
   SetIndexBuffer(6,bandUp2);
   SetIndexBuffer(7,bandDn2);
	IndicatorShortName(UniqueID); 
	  tolerance = MathMax(TouchesTolerance,0);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i); if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int start()
{
   int countedBars = IndicatorCounted();
      if (countedBars<0) return(-1);
      if (countedBars>0) countedBars--;
         int drawBars = DrawBars; if (drawBars<1) drawBars = Bars;
         int limit = MathMin(MathMin(Bars-countedBars,Bars-1),drawBars);
            window = WindowFind(UniqueID);

   //
   //
   //
   //
   //
   
   for (int i=limit; i>=0; i--)
   {
   
   
   
      
      double udeviation = iStdDev(NULL,0,BBPeriod,0,0,0,i);
      double ddeviation = iStdDev(NULL,0,BBPeriod,0,0,0,i);
      
      double ma = iMA(NULL,0,BBPeriod,0,MODE_SMA,BBPrice,i);
         bandUp[i]  =  BBDeviations1*udeviation;
         bandDn[i]  = -BBDeviations1*ddeviation;
         bandUp2[i] =  BBDeviations2*udeviation;
         bandDn2[i] = -BBDeviations2*ddeviation;
         open[i]    = Open[i] -ma;
         close[i]   = Close[i]-ma;
         high[i]    = High[i] -ma;
         low[i]     = Low[i]  -ma;
         drawCandle(i);
         if (TouchesVisible) drawTouches(i);
   }
   return(0);
}

  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void drawTouches(int i)  
{
   datetime time = Time[i];
   string name = UniqueID+":"+time+":t";
      ObjectDelete(name+"u1");
      ObjectDelete(name+"u2");
      ObjectDelete(name+"d1");
      ObjectDelete(name+"d2");
         if (safeDivide(high[i],bandUp[i] ,tolerance)) drawDot(name+"u1",time,TouchUpColor1,bandUp[i]);
         if (safeDivide(high[i],bandUp2[i],tolerance)) drawDot(name+"u2",time,TouchUpColor2,bandUp2[i]);
         if (safeDivide(low[i] ,bandDn[i] ,tolerance)) drawDot(name+"d1",time,TouchDnColor1,bandDn[i]);
         if (safeDivide(low[i] ,bandDn2[i],tolerance)) drawDot(name+"d2",time,TouchDnColor2,bandDn2[i]);
}
bool safeDivide(double value1, double value2, double tol)
{
   if (value2!=0)
         return(100.0*(MathAbs(value1-value2)/MathAbs(value2))<=tol);
   else  return(false);    
}
void drawDot(string name, datetime time, color theColor, double atValue)
{
      ObjectCreate(name,OBJ_ARROW,window,0,0,0,0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_TIME1,time);
         ObjectSet(name,OBJPROP_PRICE1,atValue);
         ObjectSet(name,OBJPROP_BACK,DrawAsBack);
         ObjectSet(name,OBJPROP_ARROWCODE,ArrowsCode);
         ObjectSet(name,OBJPROP_WIDTH,ArrowsSize);
}

//
//
//
//
//

void drawCandle(int i)
{
   datetime time = Time[i];
   string   name = UniqueID+":"+time+":";
   
      ObjectCreate(name,OBJ_TREND,window,0,0,0,0);
         ObjectSet(name,OBJPROP_COLOR,WickColor);
         ObjectSet(name,OBJPROP_TIME1,time);
         ObjectSet(name,OBJPROP_TIME2,time);
         ObjectSet(name,OBJPROP_PRICE1,MathMax(high[i],MathMin(close[i],open[i])));
         ObjectSet(name,OBJPROP_PRICE2,MathMin(low[i] ,MathMax(close[i],open[i])));
         ObjectSet(name,OBJPROP_RAY ,false);
         ObjectSet(name,OBJPROP_BACK,DrawAsBack);
      
   //
   //
   //
   //
   //
         
   name = name+"body";
      ObjectCreate(name,OBJ_TREND,window,0,0,0,0);
         ObjectSet(name,OBJPROP_TIME1,time);
         ObjectSet(name,OBJPROP_TIME2,time);
         ObjectSet(name,OBJPROP_PRICE1,open[i]);
         ObjectSet(name,OBJPROP_PRICE2,close[i]);
         ObjectSet(name,OBJPROP_WIDTH,BodyWidth);
         ObjectSet(name,OBJPROP_RAY  ,false);
         ObjectSet(name,OBJPROP_BACK,DrawAsBack);
         if (open[i]<close[i])
               ObjectSet(name,OBJPROP_COLOR,BodyUpColor);
         else  ObjectSet(name,OBJPROP_COLOR,BodyDownColor);
}